image: docker:latest

stages:
- Build dependent images
- Fetch dependencies and compile frontend
- Test
- Build production image

Compile js and scss:
  image: node:latest
  stage: Fetch dependencies and compile frontend
  artifacts:
    expire_in: 1 hour
    paths:
    - public/css
    - public/js
    - public/images
    - public/mix-manifest.json
  script:
  - yarn install
  - yarn run prod

Install php dependencies:
  image: roquie/composer-parallel:latest
  stage: Fetch dependencies and compile frontend
  artifacts:
    expire_in: 30 min
    paths:
    - vendor
  script: composer install --no-scripts --no-progress

Run phpunit tests:
  image: tmaier/docker-compose
  tags:
  - only-docker
  stage: Test
  dependencies:
  - Compile js and scss
  - Install php dependencies
  artifacts:
    when: always
    expire_in: 1 week
    paths:
    - storage/logs/laravel.log
  variables:
    COMPOSE_PROJECT_NAME: ${CI_COMMIT_SHA}_1_bookclub-rewrite
  script:
  - cp .env.example .env
  - docker-compose up -d webserver db
  - docker-compose exec -u $(id -u):$(id -g) -T webserver php artisan key:generate
  - docker-compose exec -u $(id -u):$(id -g) -T webserver php vendor/bin/phpunit
  after_script:
  - docker-compose down

Run dusk tests:
  image: tmaier/docker-compose
  tags:
  - only-docker
  stage: Test
  dependencies:
  - Compile js and scss
  - Install php dependencies
  artifacts:
    when: always
    expire_in: 1 week
    paths:
    - tests/Browser/screenshots
    - storage/logs/laravel.log
  variables:
    COMPOSE_PROJECT_NAME: ${CI_COMMIT_SHA}_2_bookclub-rewrite
  script:
  - cp .env.example .env
  - docker-compose up -d webserver db selenium-hub chrome
  - chmod a+w storage -R
  - docker-compose exec -u $(id -u):$(id -g) -T webserver php artisan key:generate
  - docker-compose exec -u $(id -u):$(id -g) -T webserver php artisan dusk
  after_script:
  - docker-compose down

Build production image:
  only:
  - master
  - production
  - development
  tags:
  - only-docker
  stage: Build production image
  cache: {}
  dependencies:
  - Compile js and scss
  - Install php dependencies
  script:
  - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
  - DOCKER_TAG="registry.gitlab.com/tokatpohb/bookclub-rewrite/build:${CI_COMMIT_SHA:0:9}"
  - docker build --tag $DOCKER_TAG -f config/Dockerfile.prod .
  - docker push $DOCKER_TAG
